// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"fmt"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"go.phucam.tv/ent/portallegal"
	"go.phucam.tv/ent/predicate"
)

// PortalLegalDelete is the builder for deleting a PortalLegal entity.
type PortalLegalDelete struct {
	config
	hooks    []Hook
	mutation *PortalLegalMutation
}

// Where appends a list predicates to the PortalLegalDelete builder.
func (pld *PortalLegalDelete) Where(ps ...predicate.PortalLegal) *PortalLegalDelete {
	pld.mutation.Where(ps...)
	return pld
}

// Exec executes the deletion query and returns how many vertices were deleted.
func (pld *PortalLegalDelete) Exec(ctx context.Context) (int, error) {
	var (
		err      error
		affected int
	)
	if len(pld.hooks) == 0 {
		affected, err = pld.sqlExec(ctx)
	} else {
		var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
			mutation, ok := m.(*PortalLegalMutation)
			if !ok {
				return nil, fmt.Errorf("unexpected mutation type %T", m)
			}
			pld.mutation = mutation
			affected, err = pld.sqlExec(ctx)
			mutation.done = true
			return affected, err
		})
		for i := len(pld.hooks) - 1; i >= 0; i-- {
			if pld.hooks[i] == nil {
				return 0, fmt.Errorf("ent: uninitialized hook (forgotten import ent/runtime?)")
			}
			mut = pld.hooks[i](mut)
		}
		if _, err := mut.Mutate(ctx, pld.mutation); err != nil {
			return 0, err
		}
	}
	return affected, err
}

// ExecX is like Exec, but panics if an error occurs.
func (pld *PortalLegalDelete) ExecX(ctx context.Context) int {
	n, err := pld.Exec(ctx)
	if err != nil {
		panic(err)
	}
	return n
}

func (pld *PortalLegalDelete) sqlExec(ctx context.Context) (int, error) {
	_spec := &sqlgraph.DeleteSpec{
		Node: &sqlgraph.NodeSpec{
			Table: portallegal.Table,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeInt,
				Column: portallegal.FieldID,
			},
		},
	}
	if ps := pld.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	affected, err := sqlgraph.DeleteNodes(ctx, pld.driver, _spec)
	if err != nil && sqlgraph.IsConstraintError(err) {
		err = &ConstraintError{msg: err.Error(), wrap: err}
	}
	return affected, err
}

// PortalLegalDeleteOne is the builder for deleting a single PortalLegal entity.
type PortalLegalDeleteOne struct {
	pld *PortalLegalDelete
}

// Exec executes the deletion query.
func (pldo *PortalLegalDeleteOne) Exec(ctx context.Context) error {
	n, err := pldo.pld.Exec(ctx)
	switch {
	case err != nil:
		return err
	case n == 0:
		return &NotFoundError{portallegal.Label}
	default:
		return nil
	}
}

// ExecX is like Exec, but panics if an error occurs.
func (pldo *PortalLegalDeleteOne) ExecX(ctx context.Context) {
	pldo.pld.ExecX(ctx)
}
